module Core.Handlers where

import qualified Core.Configuration     as Conf
import           Core.Rendering 
import           Fragments.Base
import           Fragments.NotFound

import           Control.Monad.IO.Class (liftIO)
import           Lucid                  (Html)
import           Web.Twain

index :: ResponderM a
index = do 
  title  <- liftIO Conf.appTitle
  homeMd <- liftIO $ mdFileToLucid "./data/posts/home.md"
  sendLucidFragment $ basePage title (baseHome homeMd)

postsIndex :: [FilePath] -> ResponderM a
postsIndex postNames = do
  title <- liftIO Conf.appTitle
  sendLucidFragment $ basePage title (postIndex postNames)

posts :: FilePath -> ResponderM a 
posts postName = do
  title <- liftIO Conf.appTitle
  postMd <- liftIO $ mdFileToLucid ("./data/posts/" ++ postName ++ ".md")
  sendLucidFragment $ basePage title (basePost postMd)

contact :: ResponderM a
contact = do
  title <- liftIO Conf.appTitle
  contactMd <- liftIO $ mdFileToLucid "./data/posts/contact.md"
  sendLucidFragment $ basePage title (baseContact contactMd)

feed :: ResponderM a
feed = do
  title <- liftIO Conf.appTitle
  sendLucidFragment $ basePage title baseFeed
  
missing :: ResponderM a
missing = sendLucidFragment pageNotFound

sendLucidFragment :: Html () -> ResponderM a
sendLucidFragment x = send $ html $ lucidToTwain x
